unit DoomCelRep;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ScrX: TEdit;
    ScrY: TEdit;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function GetShapeWidth(data:integer):integer;
    function GetShapeHeight(data:integer):integer;
    function GetSwap32(data:integer):integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
 CELfile: TFileStream;
 DoomFile: TfileStream;
 I: integer;
 Signature1,Signature2: integer;
 PDAToffs:integer;
 PLUToffs: integer;
 DataInt: integer;
 Strange: integer;
 PDATbuf: array of byte;
 PLUTbuf: array of byte;
 CCBbuf: array of byte;
 returnhere, curpos: integer;
 PlutSecSize: integer;
 Pdatsecsize: integer;
 PRE0,PRE1:integer;
 Xsize,Ysize: integer;
 swpdat: integer;
begin
 OpenDialog1.Execute;
 //Signature:=
 if OpenDialog1.FileName<>'' then
  begin
    //ShowMessage(OpenDialog1.Files.Text);
   for I := 0 to OpenDialog1.Files.Count-1 do
    BEGIN
    try
     DoomFile:= TFileStream.Create(OpenDialog1.Files.Strings[i],fmOpenRead);
     Strange:=0;
     DoomFile.Seek(0,0);
     DoomFile.Read(Strange,4); ///  
     Signature1:=0;
     DoomFile.Seek(0,0);
     DoomFile.Read(Signature1,1);
     DoomFile.Seek(4,0);
     DoomFile.Read(Signature2,4);
     if (Signature2<>0) and ((Signature1<>$47) or
        (Signature1<>$67)) then
                       begin
                         DoomFile.Free;
                         continue;
                       end;
     DoomFile.Read(PDAToffs,4);
                              asm
                                  mov eax,PDAToffs
                                       bswap eax
                                  mov PDAToffs,eax
                              end;

     returnhere:= DoomFile.Position;
     DoomFile.Position:= DoomFile.Position+PDAToffs;
     Pdatsecsize:= DoomFile.Size-DoomFile.Position;
     SetLength(PDATbuf,DoomFile.Size-DoomFile.Position);

     DoomFile.ReadBuffer(PDATbuf[0],DoomFile.Size-DoomFile.Position);
     DoomFile.Position:= returnhere;
     DoomFile.Read(PLUToffs,4);
                             asm
                                  mov eax,PLUToffs
                                       bswap eax
                                  mov PLUToffs,eax
                              end;
     if PLUToffs <> 0 then
     begin
     PlutSecSize:= PDAToffs-PLUToffs; ///  PLUTa
     curpos:= DoomFile.Position+PLUToffs;
     DoomFile.Position:=CurPos;
     SetLength(PLUTbuf,PlutSecSize-4);
     DoomFile.Read(PLUTbuf[0],PlutSecSize-4);
     end;
     curpos:= $3C;
     DoomFile.Seek(0,0);
     SetLength(CCBbuf,curpos);
     DoomFile.Read(CCBbuf[0],curpos);

     CELfile:= TFileStream.Create(OpenDialog1.Files.Strings[i]+'.CEL',fmCreate);
     DataInt:=541213507;
     CELfile.Write(DataInt,4); /// eto 'CCB '
     swpdat:= GetSwap32($50{PDAToffs});
     CELfile.Write(swpdat,4);
     DataInt:=0;
     CELfile.Write(DataInt,4);
     CELfile.Write(CCBbuf[0],curpos);

     ///      
     DoomFile.Position:= curpos-8;
     DoomFile.Read(PRE0,4);
                              asm
                                  mov eax,PRE0
                                       bswap eax
                                  mov PRE0,eax
                              end;
     DoomFile.Position:= curpos-4;
     DoomFile.Read(PRE1,4);
                              asm
                                  mov eax,PRE1
                                       bswap eax
                                  mov PRE1,eax
                              end;

     Xsize:= GetShapeWidth(PRE1);
     Ysize:= GetShapeHeight(PRE0);
                              asm
                                  mov eax,Xsize
                                       bswap eax
                                  mov Xsize,eax
                              end;
                              asm
                                  mov eax,Ysize
                                       bswap eax
                                  mov Ysize,eax
                              end;
     ////    
     //swpdat:=GetSwap32(Xsize);
     CELfile.Write(Xsize,4);
     //swpdat:=GetSwap32(Ysize);
     CELfile.Write(Ysize,4);

     ///   PLUT
     if PLUToffs <> 0 then
     begin
     DataInt:=1414876240;  ///  PLUT
     CELfile.Write(DataInt,4);
     swpdat:= GetSwap32(PlutSecSize+8);
     CELfile.Write(swpdat,4);
     DataInt:=GetSwap32($10);
     CELfile.Write(DataInt,4);
     CELfile.Write(PLUTbuf[0],PlutSecSize-4);
     end;

     ///   PDAT
     DataInt:=1413563472;  ///  PDAT
     CELfile.Write(DataInt,4);
     DataInt:=Pdatsecsize+8;
     swpdat:=GetSwap32(DataInt);
     CELfile.Write(swpdat,4);
     CELfile.Write(PDATbuf[0],Pdatsecsize);
     ///finish
     except
        Memo1.Lines.Add('error_'+OpenDialog1.Files.Strings[i]);
        continue;
     end;

     try
      CELfile.Free;
     except

     end;
     try
      DoomFile.Free;
     except

     end;
    END;
    ShowMessage('Finished');
  end;
end;

function TForm1.GetShapeWidth(data: Integer):integer;
begin
 result:= (data and $7FF)+1;
end;

function TForm1.GetShapeHeight(data: Integer):integer;
begin
 result:= (((data shr 6) AND $3FF) + 1);
end;

function TForm1.GetSwap32(data: Integer):integer;
begin
                               asm
                                  mov eax,data
                                       bswap eax
                                  mov data,eax
                              end;
   result:=data;
end;

end.
